#!/bin/rc
#
# mild attacks, together and separate, by week, by dow, and by hour of the day.
#
# mild: /etc/passwd, guest/visitor/demo probes
#
# severe: attempted root/bin/sys logins.
#
# ftp /etc/passwd probe rates, 
# guest/visitor/demo probe rates
# login root/bin/sync/uucp probe rates
# plot these weekly for the whole year.
#

fn dt{	awk '
function jday(y, m, d,    days, n) { 
	n = days[m] + d
	if (y % 4 == 0 && m > 2) # leap year from 1901 to 2099
        	n++;
	return n
}

BEGIN	{	months = "JanFebMarAprMayJunJulAugSepOctNovDec"
 			split("31 28 31 30 31 30 31 31 30 31 30 31", lengths)
		sum = 0;
		for (i = 1; i < 12+1; i++) {
			days[i] = sum;
			sum += lengths[i];
		}
	}
	{
		month = 1 + (index(tolower(months), tolower($1)) - 1)/3
		jdate = jday(1992, month, $2, days)
		split($3, time)
		tod = time[1]
		dow = (1 + jdate) % 7
		print jdate, tod, dow
	}
' }

cd /tmp/logs


join fingers.bad fingers.all | sort -n >/tmp/fingers

grap <<'!!' | tee fingers.pic | pic | troff >fingers.plot
.G1
frame ht 4 wid 4 bot solid left solid top invis right invis
label left "" "Probes" "per" "week" left 0.4
ticks bot at 0 "", 31 "", 59 "", 90 "", 120 "", 151 "", 181 "", 212 "", 243 "", 273 "", 304 "", 334 "", 366 ""
ticks bot out .00001 down 0.03  at 0+16 "Jan", 31+16 "Feb", 59+16 "Mar", 90+16 "Apr", 120+16 "May", 151+16 "Jun", 181+16 "Jul", 212+16 "Aug", 243+16 "Sep", 273+16 "Oct", 304+16 "Nov", 334+16 "Dec"
margin = 0
lastftp = 0
lastguest = 0
copy "/tmp/fingers" thru {
	line from $1, lastftp to $1, $2
	line from $1, $2 to $1+7, $2
	lastftp = $2
	line from $1, lastguest to $1, $2+$3
	line from $1, $2+$3 to $1+7, $2+$3 
	lastguest = $2+$3
}
line from 365, lastguest to 365, 0
.G2
!!

exit

grap <<'!!' | tee hackersdow.pic | pic | troff >hackersdow.plot
.G1
frame ht 2 wid 3 top invis right invis
coord x 0,7 y 0, 350
label left "Probes" "per" "week" left .3
ticks left out
ticks bot out .00001 down 0.03 at 0.5 "Mon", 1.5 "Tue", 2.5 "Wed", 3.5 "Thu", 4.5 "Fri", 5.5 "Sat", 6.5 "Sun"
copy "/tmp/hackers.dow" thru {
	line from $1, 0 to $1, $2
	line from $1, $2 to $1+1, $2
	line from $1+1, $2 to $1+1, 0
}
line from 7,0 to 0,0
.G2
!!


sort -u hosts.login hosts.finger |
	grep -v '[a-z]' >hosts.lookup
sort -u hosts.login hosts.finger |
	grep '[a-z]' >hosts.ok

exit


{
	awk '{print $5, $6}' <loginsum
	grep '===' misc | grep rlogin	|
		sed 's/^.*@//'		|
		awk '{print $NF, $1}'
} |
grep 'root|td|ches|adb|dmr|berferd|rtm|bin|nobody|sysadm|system|log|authenticator|sys|sysop|field|adm|ingres' |
awk '{print $NF}' >hosts.login

grep finger misc |
	grep 'root|td|ches|adb|dmr|berferd|rtm|bin|nobody|sysadm|system|log|authenticator|sys|sysop|field|adm|ingres' | awk '{print $NF}' >hosts.finger

exit



awk '{print 7*(int($1)/7)}' </tmp/hackershours |
	sort -n | uniq -c | awk '{print $2, $1}' >/tmp/daydist

awk '{print 1800*int($2/1800)}' </tmp/hackershours |
	sort -n | uniq -c | awk '{print $2, $1}' >/tmp/timedist


grap <<'!!' > hackershours.pic
.G1
frame ht 4 wid 4 bot solid left solid top solid right solid
coord x 0, 366 y 0, 24*3600
define	bullet	"$\cdot$"
ticks left out from 0*3600 to 24*3600 by 3600 ""
ticks left out .00001 left 0.09 at 0*3600 "6 AM", 3*3600 "9 AM", 6*3600 "Noon", 9*3600 "3 PM", 12*3600 "6 PM", 15*3600 "9 PM", 18*3600 "Mid.", 21*3600 "3 AM"
ticks bot at 0 "", 31 "", 59 "", 90 "", 120 "", 151 "", 181 "", 212 "", 243 "", 273 "", 304 "", 334 "", 366 ""
ticks bot out .00001 down 0.03  at 0+16 "Jan", 31+16 "Feb", 59+16 "Mar", 90+16 "Apr", 120+16 "May", 151+16 "Jun", 181+16 "Jul", 212+16 "Aug", 243+16 "Sep", 273+16 "Oct", 304+16 "Nov", 334+16 "Dec"
copy "/tmp/hackershours" thru {
	"$\cdot$" at $1,$2
}
.G2
!!

grap <<'!!' | tee hackersdaysdist.pic | pic | troff >hackersdaysdist.plot
.G1
frame ht 2 wid 2 bot solid left solid top invis right invis
label left "Probes" "per" "week" left 0.3
ticks bot at 0 "", 31 "", 59 "", 90 "", 120 "", 151 "", 181 "", 212 "", 243 "", 273 "", 304 "", 334 "", 366 ""
ticks bot out .00001 down 0.03  at 0+16 "J", 31+16 "F", 59+16 "M", 90+16 "A", 120+16 "M", 151+16 "J", 181+16 "J", 212+16 "A", 243+16 "S", 273+16 "O", 304+16 "N", 334+16 "D"
draw solid
copy "/tmp/daydist"
.G2
!!

grap <<'!!' | tee hackershourdist.pic | pic | troff >hackershourdist.plot
.G1
frame ht 2 wid 2 bot solid left solid top invis right invis
label left "Probes" "per" "half" "hour" left 0.3
ticks bot from 0*3600 to 24*3600 by 3600 ""
ticks bot down 0.09 at 0*3600+1800 "6 AM", 3*3600+1800 "9 AM", 6*3600+1800 "Noon", 9*3600+1800 "3 PM", 12*3600+1800 "6 PM", 15*3600+1800 "9 PM", 18*3600+1800 "Mid.", 21*3600+1800 "3 AM"
draw solid
copy "/tmp/daydist"
.G2
!!

exit

awk '{print (($1 + 1) % 7)}' </tmp/hackershours	|
	sort -n | uniq -c | awk '{print $2, $1}' >/tmp/hackers.dow

grap <<'!!' | tee minor.pic | pic | troff >minor.plot
.G1
frame ht 3 wid 4 bot solid left solid top invis right invis
define	bullet	% $\cdot$ %
label left "Probes" "per" "week" left .3
ticks left out at 0, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100
ticks bot at 0 "", 31 "", 59 "", 90 "", 120 "", 151 "", 181 "", 212 "", 243 "", 273 "", 304 "", 334 "", 366 ""
ticks bot out .00001 down 0.03  at 0+16 "Jan", 31+16 "Feb", 59+16 "Mar", 90+16 "Apr", 120+16 "May", 151+16 "Jun", 181+16 "Jul", 212+16 "Aug", 243+16 "Sep", 273+16 "Oct", 304+16 "Nov", 334+16 "Dec"
draw solid
lastftp = 0
lastguest = 0
copy "/tmp/minor" thru {
	line dotted from $1, lastftp to $1, $2
	line dotted from $1, $2 to $1+7, $2
	lastftp = $2
	line from $1, lastguest to $1, $2+$3
	line from $1, $2+$3 to $1+7, $2+$3 
	lastguest = $2+$3
}
line from 365, lastguest to 365, 0
.G2
!!

grap <<'!!' | tee major.pic | pic | troff >major.plot
.G1
frame ht 3*0.4 wid 4 bot solid left solid top invis right invis
define	bullet	% $\cdot$ %
coord x 0, 366 y 0, 40
ticks bot at 0 "", 31 "", 59 "", 90 "", 120 "", 151 "", 181 "", 212 "", 243 "", 273 "", 304 "", 334 "", 366 ""
ticks bot out .00001 down 0.03  at 0+16 "Jan", 31+16 "Feb", 59+16 "Mar", 90+16 "Apr", 120+16 "May", 151+16 "Jun", 181+16 "Jul", 212+16 "Aug", 243+16 "Sep", 273+16 "Oct", 304+16 "Nov", 334+16 "Dec"
label left "Probes" "per" "week" left .3
ticks left out at 0, 10, 20, 30, 40
draw solid
lastftp = 0
lastguest = 0
copy "/tmp/major" thru {
	line from $1, lastguest to $1, $2
	line from $1, $2 to $1+7, $2
	lastguest = $2
}
line from 365, lastguest to 365, 0
.G2
!!

exit

cat proxysum	|
	sed '	s/tcp!//
		s/dk!//
		s/tcp\.//
		s:/cs/::'	| 
	sed 's/^[^! ]*!//'	| 
	sed '	s/^79[ 	]/finger /
		s/^23[ 	]/telnet /
		s/^21[ 	]/ftp /
		s/^800[ 	]/fsb /
		s/^540[ 	]/uucp /
		s/^53[ 	]/dns /
		s/^25[ 	]/smtp /
		s/^3000[ 	]/weather /
		s/^5202[ 	]/xnetlib /
		s/^2000[ 	]/callsigns /
		s/^5000[ 	]/dragonmud /
	' | 
	awk '{
		count[$1]++
		if ($3 >= 0)
			outc[$1] += $3
		if ($4 >= 0)
			inc[$1] += $4
		}
	END {	for (i in count)
			print i, count[i], outc[i], inc[i]
	}' |
	sort +1rn -2 >proxysums

exit

cat proxysum	|
	sed '	s/tcp!//
		s/dk!//
		s/tcp\.//
		s:/cs/::'	| 
	awk '{print $1}'	|
	sed 's/^.*!//'		|
	sed '	s/^79$/finger/
		s/^23$/telnet/
		s/^21$/ftp/
		s/^800$/fsb/
		s/^540$/uucp/
		s/^53$/dns/
		s/^25$/smtp/
		s/^3000$/weather/
		s/^5202$/xnetlib/
		s/^2000$/callsigns/
		s/^5000$/dragonmud/
	' |
	sort | uniq -c | sort -rn >proxyserv

exit



# awk '{print $7}' proxydial | sed 's/!/ /g' | awk '{print $2, $3}' >proxystrip
awk '{print $1}' <proxystrip | sort | uniq -c | sort -rn >proxyaddr &
awk '{print $NF}' <proxystrip |sed 's:/cs/::' | sed 's/tcp\.//' |
	sort | uniq -c | sort -rn >proxyserv &


grep '===' misc 				|
	grep -v 'rlogin|rsh' 			|
	grep -v '192.20.225\.[0-9][0-9]?[0-9]?'	|
	grep -v '0.0.0.0' >/tmp/misc
sed 's/^.*@//'  </tmp/misc			|
	sed 's/ ->.*$//'			|
	sort					|
	uniq -c					|
	sort -rn >/tmp/misc.sites
awk '{print $NF}' </tmp/misc			|
	sort					|
	uniq -c					|
	sort -rn >/tmp/misc.services


test -s loginsum || {
	grep 'Successful|Failed' <auth			|
	awk -F'[ ]+' '{ print $1, $2, $3, $6, $8, $9 }'	|
	sed '	s/,//g
		s/CALLER=//' 				|
	tr 'A-Z' 'a-z'					|
	awk 'NF == 4	{next}
			{print}'	>loginsum
}

test -s ftplogins || {
	grep 'USER' ftpext 		|
	tr 'A-Z' 'a-z'			|
	sed 's/\^m//'			|
	agrep -v -2 'anonymous|netlib'	|
	grep -v 'ftp$' 			|
	awk '{print $1, $2, $3, $NF}'>ftplogins
}

test -s knoblogins || {
	{
		awk '{print $1, $2, $3, $5}' <loginsum
		grep '===' misc | grep rlogin | awk '{print $1, $2, $3, $NF}'
		cat ftplogins
	} |
	grep 'guest|visitor|demo|sync|who|uucp' | dt |
	sort -n >knoblogins
}

test -s knoblogins.byweek || {
	awk '{print $1}' <knoblogins |
		uniq -c | awk '
			BEGIN	{ for (i=0; i<52; i++)
					count[i] = 0 }
				{ count[int(($2-1)/7)] += $1 }
			END	{ for (i=0; i<52; i++)
					print i*7, count[i]}' |
		sort >knoblogins.byweek
}

test -s hostilelogins || {
	{
		awk '{print $1, $2, $3, $5}' <loginsum
		grep '===' misc | grep rlogin | awk '{print $1, $2, $3, $NF}'
		cat ftplogins
	} |
	grep 'root|td|ches|adb|dmr|berferd|rtm|bin|nobody|sysadm|system|log|authenticator|sys|sysop|field|adm|ingres' | dt |
	sort -n >hostilelogins
}

test -s hostilelogs.byweek || {
	awk '{print $1}' <hostilelogins |
		uniq -c | awk '
			BEGIN	{ for (i=0; i<52; i++)
					count[i] = 0 }
				{ count[int(($2-1)/7)] += $1 }
			END	{ for (i=0; i<52; i++)
					print i*7, count[i]}' |
		sort >hostilelogs.byweek
}

test -s ftppw.byweek || {
	grep '/etc/passwd' ftpext | dt | awk '{print $1}' |
		uniq -c | awk '
			BEGIN	{ for (i=0; i<52; i++)
					count[i] = 0 }
				{ count[int(($2-1)/7)] += $1 }
			END	{ for (i=0; i<52; i++)
					print i*7, count[i]}' |sort >ftppw.byweek
}

test -s fingers || {
	grep finger misc |
		awk '{print $1, $2, $3, $9}' >fingers
}

test -s fingers.all || {
	grep all <fingers | dt | awk '{print $1}' |
		uniq -c | awk '
			BEGIN	{ for (i=0; i<52; i++)
					count[i] = 0 }
				{ count[int(($2-1)/7)] += $1 }
			END	{ for (i=0; i<52; i++)
					print i*7, count[i]}' |sort >fingers.all
}

test -s fingers.bad || {
	grep 'root|td|ches|adb|dmr|berferd|rtm|bin|nobody|sysadm|system|log|authenticator|sys|sysop|field|adm|ingres' <fingers | dt | awk '{print $1}' |
		uniq -c | awk '
			BEGIN	{ for (i=0; i<52; i++)
					count[i] = 0 }
				{ count[int(($2-1)/7)] += $1 }
			END	{ for (i=0; i<52; i++)
					print i*7, count[i]}' |sort >fingers.bad
}

sed 's/:/ /g' <hostilelogins	|
	awk '{	tod = $4 + 60*$3 + 3600*$2
		tod = (tod + 18*3600) % (24*3600)
		print $1, tod
	}' >/tmp/dist

cat knoblogins hostilelogins |
sed 's/:/ /g' 	|
	awk '{	tod = $4 + 60*$3 + 3600*$2
		tod = (tod + 18*3600) % (24*3600)
		print $1, tod
	}' >/tmp/hackershours

cat hostilelogins |
sed 's/:/ /g' 	|
	awk '{	tod = $4 + 60*$3 + 3600*$2
		tod = (tod + 18*3600) % (24*3600)
		print $1, tod
	}' >/tmp/badhackershours

grap <<'!!' > badhackershours.pic
.G1
frame ht 4 wid 4 bot solid left solid top invis right invis
define	bullet	"$\cdot$"
ticks left out from 0*3600 to 24*3600 by 3600 ""
ticks left out .00001 left 0.09 at 0*3600 "6 AM", 3*3600 "9 AM", 6*3600 "Noon", 9*3600 "3 PM", 12*3600 "6 PM", 15*3600 "9 PM", 18*3600 "Mid.", 21*3600 "3 AM"
ticks bot at 0 "", 31 "", 59 "", 90 "", 120 "", 151 "", 181 "", 212 "", 243 "", 273 "", 304 "", 334 "", 366 ""
ticks bot out .00001 down 0.03  at 0+16 "Jan", 31+16 "Feb", 59+16 "Mar", 90+16 "Apr", 120+16 "May", 151+16 "Jun", 181+16 "Jul", 212+16 "Aug", 243+16 "Sep", 273+16 "Oct", 304+16 "Nov", 334+16 "Dec"
copy "/tmp/badhackershours" thru {
	"$\cdot$" at $1,$2
	tick bot in at $1 ""
}
.G2
!!

join ftppw.byweek knoblogins.byweek | sort -n >/tmp/minor

sort -n <hostilelogs.byweek >/tmp/major

grap <<!! | pic | troff >guestbyhour.plot
.G1
frame ht 4 wid 4
label bot "Hour"
label left "guest" "logins"
copy "guests.byhour"
.G2
!!

grap <<'!!' | pic | troff >guestbyday.plot
.G1
frame ht 3 wid 4
#ticks bot at 0/7 "      J", 31/7 "F", 59/7 "M", 90/7 "A", 120/7 "M", 151/7 "J", 181/7 "J", 212/7 "A", 243/7 "S", 273/7 "O", 304/7 "N", 334/7 "D" 
ticks bot at 0 "      J", 31 "F", 59 "M", 90 "A", 120 "M", 151 "J", 181 "J", 212 "A", 243 "S", 273 "O", 304 "N", 334 "D" 
define	bullet	% $\cdot$ %
label bot "Julian Date"
label left "guest" "logins"
copy "guests.byday" thru {
	line from $1, 0 to $1, $2
	line from $1, $2 to $1+1, $2
	line from $1+1, $2 to $1+1, 0
}
.G2
!!

test -s failedlogins || {
	grep ' failed ' <loginsum |
		awk 'NF == 5	{ next }
				{ print }' >failedlogins
}

awk '{print $5}' failedlogins | sort | uniq -c | sort -rn |
	grep -v '^   1 ' >faillist

grap <<'!!' | tee dist.pic | pic | troff >dist.plot
.G1
frame ht 5 wid 4 bot solid left solid top invis right invis
ticks bot at 0*86400 "", 0*86400 "", 1*86400 "", 2*86400 "", 3*86400 "", 4*86400 "", 5*86400 "",  6*86400 "" 
ticks bot out .00001 down 0.03  at 0*86400+43200 "Mon", 1*86400+43200 "Tue", 2*86400+43200 "Wed", 3*86400+43200 "Thu", 4*86400+43200 "Fri", 5*86400+43200 "Sat", 6*86400+43200 "Sun"
define	bullet	% $\cdot$ %
copy "/tmp/dist" thru {
	bullet at $1,$2
}
.G2
!!
